﻿using ProjectAccordionBus.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectAccordionBus.Drawnings;

public class DrawningAccordionBus : DrawningBus
{
    public DrawningAccordionBus(EntityAccordionBus entity) : base(110, 40)
    {
        EntityBus = entity;
    }

    public override void DrawTransport(Graphics g)
    {
        if (EntityBus == null || EntityBus is not EntityAccordionBus accordionBus || !_startPosX.HasValue || !_startPosY.HasValue)
        {
            return;
        }
        Pen pen = new(Color.Black);
        Brush additionalBrush = new SolidBrush(accordionBus.AdditionalColor);

        base.DrawTransport(g);

        Brush brushBlue = new SolidBrush(Color.Blue);
        // отсек
        g.FillRectangle(additionalBrush, _startPosX.Value + 60, _startPosY.Value, 50, 30);
        g.FillRectangle(additionalBrush, _startPosX.Value + 50, _startPosY.Value + 5, 10, 20);

        g.DrawRectangle(pen, _startPosX.Value + 60, _startPosY.Value, 50, 30);
        g.DrawRectangle(pen, _startPosX.Value + 50, _startPosY.Value + 5, 10, 20);

        // колеса
        g.FillEllipse(additionalBrush, _startPosX.Value + 65, _startPosY.Value + 25, 10, 10);
        g.FillEllipse(additionalBrush, _startPosX.Value + 95, _startPosY.Value + 25, 10, 10);

        g.DrawEllipse(pen, _startPosX.Value + 65, _startPosY.Value + 25, 10, 10);
        g.DrawEllipse(pen, _startPosX.Value + 95, _startPosY.Value + 25, 10, 10);

        if (accordionBus.Entrance)
        {
            g.FillRectangle(additionalBrush, _startPosX.Value + 78, _startPosY.Value + 10, 10, 20);

            g.DrawRectangle(pen, _startPosX.Value + 78, _startPosY.Value + 10, 10, 20);
        }

        if (accordionBus.Windows)
        {
            g.FillEllipse(brushBlue, _startPosX.Value + 65, _startPosY.Value + 5, 5, 10);
            g.FillEllipse(brushBlue, _startPosX.Value + 100, _startPosY.Value + 5, 5, 10);
            g.FillEllipse(brushBlue, _startPosX.Value + 90, _startPosY.Value + 5, 5, 10);

            g.DrawEllipse(pen, _startPosX.Value + 65, _startPosY.Value + 5, 5, 10);
            g.DrawEllipse(pen, _startPosX.Value + 100, _startPosY.Value + 5, 5, 10);
            g.DrawEllipse(pen, _startPosX.Value + 90, _startPosY.Value + 5, 5, 10);
        }
    }
}